﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace TestConnect1C
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            checkBox1.Checked = true;
            label4.Enabled = false;
            textBox4.Enabled = false;
            textBox1.Text = "D:\\1cv81.db\\Platform81Demo";
        }

        private void checkBox1_Click(object sender, EventArgs e)
        {
            if (checkBox1.Checked)
            {
                label1.Text = "Каталог БД";
                label4.Enabled = false;
                textBox4.Enabled = false;
            }
            else
            {
                label1.Text = "Сервер 1С";
                label4.Enabled = true;
                textBox4.Enabled = true;
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (checkBox1.Checked)
            {
                // Файловый вариант подключения
                connectTo1Cv81.ThisConnect_Is_COM = false;
                connectTo1Cv81.ThisDB_Is_Files = true;
                connectTo1Cv81.UserName = textBox2.Text;
                connectTo1Cv81.Password = textBox3.Text;
                connectTo1Cv81.FilePath = textBox1.Text;
                connectTo1Cv81.Active = true;
                connectTo1Cv81.Visible1Cv8 = false;
            }
            else
            {
                // Серверный вариант подключения
                connectTo1Cv81.ThisConnect_Is_COM = true;
                connectTo1Cv81.ThisDB_Is_Files = false;
                connectTo1Cv81.UserName = textBox2.Text;
                connectTo1Cv81.Password = textBox3.Text;
                connectTo1Cv81.Server = textBox1.Text;
                connectTo1Cv81.Database = textBox4.Text;
                connectTo1Cv81.Active = true;
                connectTo1Cv81.Visible1Cv8 = false;
            }
            try
            {
                // Получили Метаданные
                var Matadata = GetObjectProperty(connectTo1Cv81.ole1Cv8, connectTo1Cv81.ole1Cv8, "Метаданные");
                // Получили коллекцию справочников
                var CollectionCatalogs = GetObjectProperty(connectTo1Cv81.ole1Cv8, Matadata, "Справочники");
                // Получили количество справочников
                var CountCatalogs = InvokeObjectMethod(connectTo1Cv81.ole1Cv8, CollectionCatalogs, "Количество", new Object[] { });

                int i = 0;
                listBox1.Items.Clear();
                // Выводим имена всех справочников в ListBox
                while (i < (int)CountCatalogs)
                {
                    var cat = InvokeObjectMethod(connectTo1Cv81.ole1Cv8, CollectionCatalogs, "Получить", new Object[] { i });
                    var fullname = GetObjectProperty(connectTo1Cv81.ole1Cv8, cat, "Имя");
                    listBox1.Items.Add(fullname);
                    i++;
                }
            }
            catch
            {
                MessageBoxButtons buttons = MessageBoxButtons.OK;
                MessageBox.Show("Ошибочка получения метаданных конфигурации", "Ошибка", buttons);
            }
        }

        public object GetObjectProperty(object v81, object refObject, string propertyName)
        {
            return v81.GetType().InvokeMember(propertyName, System.Reflection.BindingFlags.GetProperty, null, refObject, null);
        }

        public object InvokeObjectMethod(object v81, object refObject, string methodName, Object[] parameters)
        {
            return v81.GetType().InvokeMember(methodName, System.Reflection.BindingFlags.Public | System.Reflection.BindingFlags.InvokeMethod | System.Reflection.BindingFlags.Static, null, refObject, parameters);
        }
    }
}
